//--
//--	wingdc.h
//--
//--	TWinGDC Class Header File
//--


#if !defined(__ULU_WINGDC_H)
#define __ULU_WINGDC_H


// Make sure we have definitions for all types we use
#if !defined(_INC_WING)
	#include <wing.h>
#endif
#if !defined(OWL_MODULE_H)
	#include <owl\module.h>
#endif
#if !defined(OWL_DC_H)
	#include <owl\dc.h>
#endif


class TWinGDC : public TDC
{
	private:
		static TModule *pWinGModule;
		static int nWinGModuleRefCount;

		HDC WINGAPI (*__WinGCreateDC)(void);
		BOOL WINGAPI (*__WinGRecommendDIBFormat)(BITMAPINFO FAR *);
		HBITMAP WINGAPI (*__WinGCreateBitmap)(HDC, BITMAPINFO const FAR *,
															void FAR *FAR *);
		void FAR *WINGAPI (*__WinGGetDIBPointer)(HBITMAP, BITMAPINFO FAR *);
		UINT WINGAPI (*__WinGGetDIBColorTable)(HDC, UINT, UINT, RGBQUAD FAR *);
		UINT WINGAPI (*__WinGSetDIBColorTable)(HDC, UINT, UINT,
														RGBQUAD const FAR *);
		HPALETTE WINGAPI (*__WinGCreateHalftonePalette)(void);
		HBRUSH WINGAPI (*__WinGCreateHalftoneBrush)(HDC, COLORREF,
														   WING_DITHER_TYPE);
		BOOL WINGAPI (*__WinGBitBlt)(HDC, int, int, int, int, HDC, int, int);
		BOOL WINGAPI (*__WinGStretchBlt)(HDC, int, int, int, int, HDC, int,
															  int, int, int);
	protected:
	public:
		TWinGDC();
		virtual ~TWinGDC();

		HBITMAP WinGCreateBitmap(BITMAPINFO far *pHeader,
													  void far *far *ppBits);

		UINT WinGGetDIBColorTable(UINT nStartIndex, UINT nNumberOfEntries,
													   RGBQUAD far *pBuffer);
		UINT WinGSetDIBColorTable(UINT nStartIndex, UINT nNumberOfEntries,
													   RGBQUAD far *pBuffer);

		BOOL WinGBitBlt(HDC hdcDest,int nXOriginDest, int nYOriginDest,
										 int nWidthDest, int nHeightDest,
										   int nXOriginSrc, int nYOriginSrc);
		BOOL WinGStretchBlt(HDC hdcDest,int nXOriginDest, int nYOriginDest,
										 int nWidthDest, int nHeightDest,
										   int nXOriginSrc, int nYOriginSrc,
											  int nWidthSrc, int nHeightSrc);

		void far *WinGGetDIBPointer(HBITMAP hbm, BITMAPINFO far *pHeader);
		BOOL WinGRecommendDIBFormat(BITMAPINFO far *pHeader);
};


inline HBITMAP TWinGDC::WinGCreateBitmap(BITMAPINFO far *pHeader,
													  void far *far *ppBits)
{
	return __WinGCreateBitmap((HDC)Handle,pHeader,ppBits);
}

inline UINT TWinGDC::WinGGetDIBColorTable(UINT nStartIndex,
											 UINT nNumberOfEntries,
													   RGBQUAD far *pBuffer)
{
	return __WinGGetDIBColorTable((HDC)Handle,nStartIndex,
												   nNumberOfEntries,pBuffer);
}

inline UINT TWinGDC::WinGSetDIBColorTable(UINT nStartIndex,
											 UINT nNumberOfEntries,
													   RGBQUAD far *pBuffer)
{
	return __WinGSetDIBColorTable((HDC)Handle,nStartIndex,
												   nNumberOfEntries,pBuffer);
}

inline BOOL TWinGDC::WinGBitBlt(HDC hdcDest,int nXOriginDest, int nYOriginDest,
										 int nWidthDest, int nHeightDest,
									   int nXOriginSrc, int nYOriginSrc)
{
	return __WinGBitBlt(hdcDest,nXOriginDest,nYOriginDest,
									   nWidthDest,nHeightDest,
										(HDC)Handle,nXOriginSrc,nYOriginSrc);
}

inline BOOL TWinGDC::WinGStretchBlt(HDC hdcDest,int nXOriginDest, int nYOriginDest,
										 int nWidthDest, int nHeightDest,
										  int nXOriginSrc, int nYOriginSrc,
											   int nWidthSrc, int nHeightSrc)
{
	return __WinGStretchBlt(hdcDest,nXOriginDest,nYOriginDest,
									  nWidthDest,nHeightDest,
									   (HDC)Handle,nXOriginSrc,nYOriginSrc,
													  nWidthSrc, nHeightSrc);
}

inline void far *TWinGDC::WinGGetDIBPointer(HBITMAP hbm,
													 BITMAPINFO far *pHeader)
{
	return __WinGGetDIBPointer(hbm,pHeader);
}


inline BOOL TWinGDC::WinGRecommendDIBFormat(BITMAPINFO far *pHeader)
{
	return __WinGRecommendDIBFormat(pHeader);
}



#endif  //  #if !defined(__ULU_WINGDC_H)

